'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function cast(v) {
  if (typeof v === "string" && v.length) {
    return isNaN(v) ? v : +v
  }
  return v
}

function castAll(o) {
  return Object.fromEntries(Object.entries(o).map(([k, v]) => [k, cast(v)]))
}

const isPrimitive = (v) => v === null || typeof v !== "object";

function nodeFromString(str) {
  const doc = new DOMParser().parseFromString(str.trim(), "text/html", {
    includeShadowRoots: true, // @todo: required?
  });

  const errorNode = doc.querySelector("parsererror");

  if (errorNode) ; else {
    return doc.head.firstChild || doc.body.firstChild
  }
}

exports.cast = cast;
exports.castAll = castAll;
exports.isPrimitive = isPrimitive;
exports.nodeFromString = nodeFromString;
